/**
 * @file ystationery.h
 * @brief °δ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-28
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YSTATIONERY
#define DEFINE_H_YSTATIONERY

#include <btron/dp.h>
#include <btron/hmi.h>
#include "ycolor.h"

/** °
 *
 * ֥饷ڥեȤʤɡ°뤿ݥ饹Ǥ
 */
class YStationery {

public:
  /** 󥹥ȥ饯
   *
   * 󥹥ȥ饯Ǥ°ξܺ٤setDrawingModeؿ򻲾
   * Ƥ
   * @param lm °
   */
  YStationery(W lm = G_STORE) {
    setDrawingMode(lm);
    setFgColor(YColor(0,0,0));
    setBgColor(YColor(255,255,255));
  }
  
  /// ǥȥ饯
  virtual ~YStationery() {}
  
  /** ⡼ɤ
   *
   * ⡼ɤꤷޤ⡼ɤ G_STORE, G_XOR, G_OR, G_AND,
   * G_CPYN, G_XORN, G_ORN, G_ANDN ΤΤ줫ꤷޤ
   * @param lm ⡼
   */
  virtual void setDrawingMode(W lm) {
    lmode = lm;
  }

  /** ߤ⡼ɤμ
   *
   * ŬѤƤ⡼ɤޤ
   * @retval ⡼
   */
  virtual W getDrawingMode() {
    return lmode;
  }

  /** ʿ
   *
   * ʿꤷޤ
   * @param col ʿ
   */
  virtual void setFgColor(YColor col) {
    fgcol = col;
  }

  /** ߤʿ
   *
   * ߤʿ֤ޤ
   * @retval ߤʿ
   */
  virtual YColor getFgColor() {
    return fgcol;
  }

  /** طʿ
   *
   * طʿꤷޤ
   * @param col طʿ
   */
  virtual void setBgColor(YColor col) {
    bgcol = col;
  }
  
  /** ߤطʿ
   *
   * ߤطʿ֤ޤ
   * @retval ߤطʿ
   */
  virtual YColor getBgColor(){
    return bgcol;
  }
  
protected:
  /// ⡼
  W lmode;
  
  /// ʿ
  YColor fgcol;
  
  /// طʿ
  YColor bgcol;

private:
  
};

#endif // DEFINE_H_YSTATIONERY
