//
// VNC Viewer for B-right/V
// (C)Copyright 2004, Yashiro Takeshi
//

#ifndef DEFINE_H_PASSWORD_INPUT_PANEL
#define DEFINE_H_PASSWORD_INPUT_PANEL

#include <basic.h>
#include <btron/hmi.h>
#include <btron/libapp.h>
#include <tstring.h>
#include <bstdio.h>
#include "databox.h"

class PasswordInputPanel {
  friend W impl_passwordInputPanel(W pnid, W ino, W value);

public:
  const static int maxlength = 14;

private:
  W panel_id;
  static TC password[maxlength+1];

public:
  PasswordInputPanel(){
    panel_id = opnstdpnl(PNL_PWDINP, 0);
    setPassword((TC[]){TNULL});
  }
  
  ~PasswordInputPanel(){
    if (panel_id >= 0){
      clsstdpnl();
    }
  }

  void setPassword(const TC* str){
    tc_strcpy(password, const_cast<TC*>(str));
    cset_val(pidstdpnl(3), tc_strlen(password)*2, (W*)password);
  }
  
  const TC* getPassword() const {
    return password;
  }
  
  int exec();
};

#endif // DEFINE_H_PASSWORD_INPUT_PANEL
