/**
 * @file ysocket.h
 * @brief TCP/IPå
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-02-01
 *
 * Copyright (C) 2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YSOCKET
#define DEFINE_H_YSOCKET

#include <basic.h>
#include <btron/btron.h>
#include <btron/bsocket.h>
// unix/arpa/inet.h ɤѤʷƤޤԹ礬???
extern int inet_pton(int, const char*, void*);

namespace YLibDraft {

/** TCP/IPå
 *
 * TCP/IPåȤϤ˴ؤåѡ饹Ǥ
 */
class YTCPSocket {

protected:

  W sock_id;
  
  hostent host_info;

  sockaddr_in server_addr;

public:
  
  YTCPSocket(W mode = SOCK_STREAM);
  
  virtual ~YTCPSocket() {
    close();
  };

  // throws IOException?
  //void connect(const YString& hostname, int port);

  void connect(const char* hostname, unsigned short port);

  void close() {
    if (sock_id >= 0){
      so_close(sock_id);
    }
  }

  void read(B* p, int nbytes);
  
  void write(const B* p, int nbytes);

};

}

#endif // DEFINE_H_YSOCKET
