/**
 * @file ycolor.h
 * @brief 24ӥåȿ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-28
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YCOLOR
#define DEFINE_H_YCOLOR

#include <btron/dp.h>
#include <btron/hmi.h>

/** 24ӥåȿѥ饹
 *
 * 24ӥåȤοǡ򰷤Υ饹ǡŪˤCOLORФ
 * åѤǤ롣
 */
class YColor {

public:
  /// ǥեȥ󥹥ȥ饯
  YColor() {
    colorval = 0x10000000;
  }
  
  /** RGBˤ륳󥹥ȥ饯
   *
   * RGBˤ꿧ޤ
   * @param r ֶ (0255)
   * @param g - ж (0255)
   * @param b - Ķ (0255)
   */
  YColor(W r,W g,W b) {
    colorval = 0x10000000;
    setRGB(r, g, b);
  }
  
  /// ǥȥ饯
  ~YColor() {}
  // : virtualؿˤƤʤΤդ뤳ȡ
  
  /** COLOR
   *
   * бCOLOR֤ͤޤ
   * @retval COLOR
   */
  COLOR getColorValue() {
    return colorval;
  }

  /** ʬζ٤
   *
   * ʬζ٤ޤͤ0255ϰǤ
   * @retval ֶ
   */
  W getRValue() {
    return RED(colorval);
  }
  
  /** ʬζ٤
   *
   * ʬζ٤ޤͤ0255ϰǤ
   * @retval Ķ
   */
  W getBValue()
  {
    return BLUE(colorval);
  }
  
  /** ʬζ٤
   *
   * ʬζ٤ޤͤ0255ϰǤ
   * @retval ж
   */
  W getGValue() {
    return GREEN(colorval);
  }

  /** ʬζ٤
   *
   * ʬζ٤ꤷޤͤ0255ϰǤ
   * @param val ֶ
   */
  void setRValue(W val) {
    colorval &= 0xff00ffff;
    colorval |= ((val & 0xff) << 16);
  }

  /** ʬζ٤
   *
   * ʬζ٤ꤷޤͤ0255ϰǤ
   * @param val Ķ
   */
  void setBValue(W val) {
    colorval &= 0xffffff00;
    colorval |= (val & 0xff);
  }

  /** ʬζ٤
   *
   * ʬζ٤ꤷޤͤ0255ϰǤ
   * @param val ж
   */
  void setGValue(W val) {
    colorval &= 0xffff00ff;
    colorval |= ((val & 0xff) << 8);
  }
  
  /** RGBˤ뿧
   *
   * RGBˤ뿧Ԥޤ
   * @param r ֶ
   * @param g ж
   * @param b Ķ
   */
  void setRGB(W r, W g, W b) {
    // ΤäȤȽľޤ礦
    setRValue(r);
    setGValue(g);
    setBValue(b);
  }
  
protected:

private:
  /// COLOR
  COLOR colorval;

};

#endif // DEFINE_H_COLOR
