/**
 * @file ypoint.h
 * @brief ɸ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-30
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YPOINT
#define DEFINE_H_YPOINT

#include <basic.h>
#include <bstdlib.h>
#include <tcode.h>
#include <errcode.h>
#include <btron/btron.h>
#include <btron/dp.h>
#include "ypoint.h"

/** ɸ
 *
 * ɸ򰷤Υ饹ǤŪˤPNT¤Τ
 * ǽɲäΤǤ
 *
 * <strong>ѿ x, y ľܥǤ</strong>Ȥ
 * αդƤ
 */
class YPoint : public point {
public:
  /// ǥեȥ󥹥ȥ饯
  YPoint() {}

  /** 󥹥ȥ饯
   *
   * 󥹥ȥ饯ɸꤷƥ֥Ȥޤ
   * @param nex Xɸ
   * @param ney Yɸ
   */
  YPoint(W nex, W ney) {
    x = nex;
    y = ney;
  }

  /** ԡ󥹥ȥ饯
   *
   * PNT¤ΤΥԡ󥹥ȥ饯
   * @param src ԡPNT¤
   */
  YPoint(const PNT& src){
    operator=(src);
  }

  /// ǥȥ饯
  ~YPoint() {}
  
  /** 
   *
   * ɸޤ
   * @param src ɸ
   */
  const YPoint& operator=(const PNT& src) {
    x = src.x;
    y = src.y;
    return *this;
  }
  
  /** û
   *
   * Ϳ줿ɸͤäޤ
   * @param src äɸ
   */
  const YPoint& operator+=(const PNT& src) {
    x += src.x;
    y += src.y;
    return *this;
  }
  
  /** 
   * 
   * Ϳ줿ɸͤޤ
   * @param src ɸ
   */
  const YPoint& operator-=(const PNT& src) {
    x -= src.x;
    y -= src.y;
    return *this;
  }
  
  /** ()
   *
   * ɸͤɤ֤ͤޤ
   * @param src оݤκɸ
   */
  bool operator==(const PNT& src) const {
    return (x == src.x && y == src.y);
  }

  /** ()
   *
   * ɸͤ˵ۤʤ˿֤ޤ
   * @param src оݤκɸ
   */
  bool operator!=(const PNT& src) const {
    return !(operator==(src));
  }
  
protected:
  
private:
  
};

#endif // DEFINE_H_YPOINT
